;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo-cm
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(unless (find-package :compo-cm) (make-package :compo-cm))
(in-package :compo-cm)
(use-package :compo)

(when (or *reload-all*
          (not (find :note *features*)) )
  (load (make-pathname :host *host*
                       :device *device* 
                       :directory (append *compo-root* '("note"))
                       :name "package" 
                       :type *source-type*) ) )

(use-package :note)

(export '(*compo-cm-2-source* 
          *compo-cm-2-object*

          *default-midi-file*

          midi
          program-change
          init-programs
          test-programs
          cmize 

          program-change-help ))

(proclaim '(special
            *default-midi-file* ))

(setf (logical-pathname-translations "cm-2")
      `(("**;*.*" , (make-pathname :host *host*
                     :device *device*
                     :directory `(,@*compo-root* "compo-cm" "cm-2" :wild-inferiors)
                     :name :wild
                     :type :wild ))) )

(defparameter *default-midi-file*
  (make-pathname :host *host*
                 :device *device*
                 :directory *compo-root*
                 :name "compo" 
                 :type "midi")

"Parameter
   *default-midi-file*
Purpose
   The default midi file used is 'compo.midi' in the compo root directory." )

(make-and-load "cm-2:bin;midi"
               "cm-2:src;midi.lisp" )

(make-and-load "cm-2:bin;cmize"
               "cm-2:src;cmize.lisp" )

(make-and-load "cm-2:bin;program-change"
               "cm-2:src;program-change.lisp" )

(make-and-load "cm-2:bin;pton"
               "cm-2:src;pton.lisp" )

(make-and-load "cm-2:bin;grammar"
               "cm-2:src;grammar.lisp" )

(make-and-load "cm-2:bin;specialized-help"
               "cm-2:src;sugar;specialized-help.lisp" )

(make-and-load "cm-2:bin;check-program-change"
               "cm-2:src;sugar;error;check-program-change.lisp" )

(make-and-load "cm-2:bin;program-change-help"
               "cm-2:src;sugar;program-change-help.lisp" )

(pushnew :compo-cm-2 *features*)