;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(setf *default-format* :text)

(defparameter *file* (make-pathname :host *host*
                                    :device *device* 
                                    :directory `(,@*compo-root* "doc" "dev")
                                    :name "compo-cm"
                                    :type "txt" ))

(with-open-file (file *file*
                      :direction :output
                      :if-exists :supersede)
  
  (write-string "Package :compo-cm" file)
  (write-string (make-string 1 :initial-element #\newline) file)
  (write-string "-----------------" file)
  (write-string (make-string 2 :initial-element #\newline) file)
  (write-string (format-doc (documentation '*default-mode* 'variable)) file)
  (write-string (format-doc (documentation '*default-key* 'variable)) file)
  (write-string (format-doc (documentation '*default-time* 'variable)) file)
  (write-string (format-doc (documentation '*default-output-file* 'variable)) file)
  (write-string (format-doc (documentation '*default-size* 'variable)) file)
  (write-string (format-doc (documentation '*default-free-expansion-factor* 'variable)) file)
  (write-string (format-doc (documentation '*voices* 'variable)) file)
  (write-string (format-doc (documentation '*default-midi-file* 'variable)) file)
  (write-string (format-doc (documentation 'score 'function)) file)
  (write-string (format-doc (documentation 'cmnize 'function)) file)
  (write-string (format-doc (documentation 'midi 'function)) file)
  (write-string (format-doc (documentation 'cmize 'function)) file)
  (write-string (format-doc (documentation 'init-programs 'function)) file)
  (write-string (format-doc (documentation 'program-change 'function)) file)
  nil )