;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(with-open-file (file (make-pathname :host *host*
                                     :device *device* 
                                     :directory *compo-root* 
                                     :name "test"
                                     :type "txt" )
                      :direction :output
                      :if-exists :supersede )
  (let ((cr (make-string 1 :initial-element #\newline)))
    (write-string "Test of compo" file)
    (write-string cr file)
    (write-string "-------------" file)
    (write-string cr file)
    (write-string cr file)
    (write-string "Time of test : " file)
    (multiple-value-bind (s mi h d mo y dow dstp tz) (get-decoded-time)
      (declare (ignore dow s))
      (write y :stream file)
      (write-string "/" file)
      (write d :stream file)
      (write-string "/" file)
      (write mo :stream file)
      (write-string " " file)
      (write (+ h tz (if dstp -1 0)) :stream file)
      (write-string ":" file)
      (write mi :stream file)
      (write-string " GMT" file) )
    (write-string cr file)
    (write-string cr file)
    (write-string "Lisp Implementation Type : " file)
    (write-string (lisp-implementation-type) file)
    (write-string cr file)
    (write-string "Lisp Implementation Version : " file)
    (write-string (lisp-implementation-version) file)
    (write-string cr file)
    (write-string cr file)
    (write-string "Machine Type : " file)
    (write-string (machine-type) file)
    (write-string cr file)
    (write-string "Machine Version : " file)
    (write-string (machine-version) file)
    (write-string cr file)
    (write-string cr file)
    (write-string "Software Type : " file)
    (write-string (software-type) file)
    (write-string cr file)
    (write-string "Software Version : " file)
    (write-string (software-version) file)
    (write-string cr file)
    (write-string cr file)
    (write-string "package :compo" file)
    (write-string cr file)
    (write-string "--------------" file)
    (write-string cr file)
    (let ((save *standard-output*))
      (setf *standard-output* file)
      (load (make-pathname :host *host*
                           :device *device* 
                           :directory (append *compo-root* '("compo")) 
                           :name "test"
                           :type *source-type* ))
      (setf *standard-output* save) )
    (write-string cr file)
    (write-string "package :note" file)
    (write-string cr file)
    (write-string "--------------" file)
    (write-string cr file)
    (let ((save *standard-output*))
      (setf *standard-output* file)
      (load (make-pathname :host *host*
                           :device *device* 
                           :directory (append *compo-root* '("note")) 
                           :name "test"
                           :type *source-type* ))
      (setf *standard-output* save) )
    (write-string cr file)
    (write-string "package :compo-cm" file)
    (write-string cr file)
    (write-string "-----------------" file)
    (write-string cr file)
    (let ((save *standard-output*))
      (setf *standard-output* file)
      (load (make-pathname :host *host*
                           :device *device* 
                           :directory (append *compo-root* '("compo-cm")) 
                           :name "test"
                           :type *source-type* ))
      (setf *standard-output* save) ) ) )