;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defgeneric granulate-compo (compo)
  (:documentation

"Generic Function
   granulate-compo (compo)
Arguments
   compo is the composition to which the granulation is to be applied.
Values
   compo <<granulated>>.
Purpose
   When an elementary composition is reached during the standard realization process,
   according to depth consideration (see the context item 'granulation'), this 
   generic function is called to determine whether this composition will remain
   elementary in the result, or will be represented by some pattern. As an example,
   see the primary method specialized on the 'chord' class in the package :harmony
   (coming soon)." ) )

(defmethod granulate-compo ((compo compo))

"Primary method
   granulate-compo specialized on 'compo'
Purpose
   As a default, the slot 'subs' is set to nil in the composition."

  (setf (subs compo) nil) )