;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defgeneric integrate-compo (compo)
  (:documentation

"Generic Function
   integrate-compo (compo)
Arguments
   compo is the composition to which the integration is to be applied.
Values
   compo affected by the integration.
Purpose
   This generic function is intended to be called only by the realization mechanism
   specialized on the context item 'integration'. By providing new methods to the
   generic function 'integrate-compo', it is possible to specify the notion of
   integration in the system, which should be how a supercomposition integrates in its
   own numeric properties, a synthesis of the result of the realization process in its
   subcompositions." ) )

(defmethod integrate-compo ((compo compo))

"Primary method
   integrate-compo specialized 'compo'
Purpose
   As a default, the composition is left unchanged."

  compo )