;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(defun quote-expr (a)

"Function
   quote-expr (a)
Arguments
   An expression
Values
   The expression quoted if necessary to warrant that the evaluation of the result
   will give the initial expression.
Purpose
   Though it is not used in the compo package, this function is provided as a
   facility for subclasses of 'compo' that define numeric properties, such as 'note
   in the package :note.
Behaviour
   The expression is returned quoted, except in the case of expressions evaluating to
   themselves (i.e. numbers, keywords, in fact any atom that are not non-keyword
   symbols), where the expression is returned as is."
 
  (if (or (consp a)
          (and a
               (symbolp a)
               (not (keywordp a)) ) )
    (list 'quote a)
    a ) )