;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo)

(export '(*comment-descr*
          *coercer-specifier-name-descr*
          *operator-name-descr*
          *common-lisp-number-descr*
          *symbol-descr*
          *invalid-name-error*
          *unbound-reference-error*
          *hei-keyword-error*
          *dur-keyword-error*
          *pos-mod-keyword-error*
          *pos-keyword-error*
          *voi-keyword-error*
          *dyn-keyword-error*
          *hei-coercer-error*
          *dur-coercer-error*
          *pos-coercer-error*
          *voi-coercer-error*
          *dyn-coercer-error*
          *parameter-key-error*
          *program-change-error*
          *cleave-change-error*
          *err-prompt*
          *err2-prompt*
          *help-prompt* ))

(defparameter *comment-descr*
  "Toute chaine de caracteres.")

(defparameter *coercer-specifier-name-descr*
  "Le nom de tout specificateur de type Common Lisp, de tout specificateur de type
utilisateur defini au moyen de la fonction mydeftype, ou toute fonction agissant comme un
specificateur de coercition dans le sens defini dans compo.")

(defparameter *operator-name-descr*
  "Le nom de toute fonction n-aire s'appliquant exclusivement sur des nombres.")

(defparameter *common-lisp-number-descr*
  "Toute valeur v telle que (typep v 'number) est vrai.")

(defparameter *symbol-descr*
  "Tout symbole different de 'note 'cnote 'fermata 'repeat-end 'fermata-repeat-end et 'lyrics.")

(defparameter *invalid-name-error*
  "~S n'est pas un nom valide !")

(defparameter *unbound-reference-error*
  "~S ne reference pas un nom prealablement declare !")

(defparameter *hei-keyword-error*
  "~S n'est pas une hauteur musicale valide !")

(defparameter *dur-keyword-error*
  "~S n'est pas une duree musicale valide !")

(defparameter *pos-mod-keyword-error*
  "~S n'est pas un mode de positionnement valide !")

(defparameter *pos-keyword-error*
  "~S n'est pas une position valide !")

(defparameter *voi-keyword-error*
  "~S n'est pas une valeur de voix valide '") 

(defparameter *dyn-keyword-error*
  "~S n'est pas une valeur de nuance valide !")

(defparameter *hei-coercer-error*
  "~S n'est pas un specificateur de coercition sur hauteur valide !")

(defparameter *dur-coercer-error*
  "~S n'est pas un specificateur de coercition sur duree valide !")

(defparameter *pos-coercer-error*
  "~S n'est pas un specificateur de coercition sur position valide !")

(defparameter *voi-coercer-error*
  "~S n'est pas un specificateur de coercition sur voix valide !")

(defparameter *dyn-coercer-error*
  "~S n'est pas un specificateur de coercition sur dynamique valide !")

(defparameter *parameter-key-error*
  "~S n'est pas un parametre mot-cle valide !")

(defparameter *program-change-error*
  "~S n'est pas un programme midi valide !")

(defparameter *cleave-change-error*
  "~S n'est pas une nom de clef cmn valide !")

(defparameter *err-prompt*
  "Veuillez entrer une valeur valide, :help pour une description des valeurs valides,
ou :abort pour abandonner ? ")

(defparameter *err2-prompt*
  "Veuillez entrer une valeur valide ou :abort ? ")

(defparameter *help-prompt*
  "Veuillez entrer :
  :abort pour quitter l'aide
  t pour une description generale de la commande 'note'
  :hei pour une description des valeurs de hauteur valides
  :dur pour une description des valeurs de duree valides
  :pos-mod pour une description des modes de positionnement valides
  :pos pour une description des valeurs de position valides
  :voi pour une description des valeurs de voix valides
  :dyn pour une description des valeurs de nuance valides
  :parameter-key pour une description des parametres mot-cles valides
  :subs pour une description des valeurs valides pour les sous-notes
  :coerce-hei pour une description des specificateurs de coercition sur hauteurs valides
  :coerce-dur pour une description des specificateurs de coercition sur durees valides
  :coerce-pos pour une description des specificateurs de coercition sur positions valides
  :coerce-voi pour une description des specificateurs de coercition sur voix valides
  :coerce-dyn pour une description des specificateurs de coercition sur nuances valides
<help> ? ")