;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

;; mode function

(in-package :note)

(defun mode (x &rest l)

"Function
   mode (x &rest l)
Arguments
   x is a number
   l is a list of numbers
Values
   The value from l which is numerically the closest to x modulo 1200 plus 1200
   multiplied by x div 1200.
Purpose
   This function is intended to be used as a coercion specifier on heights (see
   'coercion). It is meaningfull only when used with heights belonging to a temperament
   where the octave is 1200 (this is currently the case with all the temperaments
   defined in the scope of compo)."

  (and x
       (multiple-value-bind (oct hei) (floor x 1200)
         (+ (or (apply #'closestc hei l) hei) (* oct 1200)) ) ) )