;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(defmethod clone-slots ((copied abstract-note) (copy abstract-note))

"Primary method
   clone-slots specialized on 'abstract-note'
Behaviour
   The slots 'hei', 'voi', 'pos', 'dur' and 'dyn' in the copy are set to a clone of the
   slots 'hei', 'voi', 'pos', 'dur' and 'dyn' respectively in the model after calling the
   next method."

  (call-next-method)
  (setf (hei copy) (clone (hei copied)))
  (setf (voi copy) (clone (voi copied)))
  (setf (pos copy) (clone (pos copied)))
  (setf (dur copy) (clone (dur copied)))
  (setf (dyn copy) (clone (dyn copied))) )