;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(defun check-parameter-key (val)
  
  (let ((cr (make-string 1 :initial-element #\newline)))
    (cond
     ((equal val :abort) val)
     ((or (pitchp (normalize-pitch val))
          (eq val :rest)
          (durationp val)
          (member val '(:abs :juxt :super :chord))
          (cleavep val) )
      val )
     ((equal val :help)
      (specialized-help :parameter-key)
      (write-string cr)
      (write-string *err-prompt*)
      (check-parameter-key (read)) )
     (t
      (write-string (format nil *parameter-key-error* val))
      (write-string cr)
      (write-string *err-prompt*)
      (check-parameter-key (read)) ) ) ) )