;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :note
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :note)

(defun not-a-voi-p (voi)

  (labels ((f (voi)
             (and
              (not (numberp voi))
              (not (cleavep voi))
              (not (member voi '(super-hei super-dur super-pos super-voi super-dyn
                                 prev-hei prev-dur prev-pos prev-voi prev-dyn ))) ) )

           (g (voi)
             (and voi (or (not-a-voi-p (car voi)) (g (cdr voi)))) ) )

    (and
     (f voi)
     (or (atom voi)
         (if (atom (car voi))
           (null (ignore-errors (symbol-function (car voi))))
           (progn
             (null (ignore-errors (symbol-function (caar voi))))
             (g (cdar voi)) ) )
         (g (cdr voi)) ) ) ) )