;;; A Common Lisp implementation of the compo protocol Version 2
;;;
;;; Package :compo-cm
;;;
;;; Copyright (C) 2001  Bruno LARTILLOT
;;; 
;;; This program is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU General Public License
;;; as published by the Free Software Foundation; either version 2
;;; of the License, or any later version.
;;;
;;; This program is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;; GNU General Public License for more details.
;;;
;;; You should have received a copy of the GNU General Public License
;;; along with this program; if not, write to the Free Software
;;; Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

(in-package :compo-cm)

(setf *default-syntax* :english)

(setf *bwv245*
      (note "BWV 245 - O Grosse Lieb" :pos 3
       lyrics=(("O")("gro-")("sse")("Lieb,")
               ("o")("Lieb")("ohn")("al-")("le")("Ma-" :h)("sse,")
               ("die")("dich")("ge-")("bracht")("auf")("die-")("se")("Mar-")("ter-")("stra-" :h)("sse!")
               ("Ich")("leb-")("te")("mit")("der")("Welt")("in")("Lust")("und")("Freu-" :h)("den,")
               ("und")("du")("musst")("lei-" :h)("den!" :h.))
       (lyrics :soprano :super lyrics)
       (lyrics :tenor :super lyrics)

       (:soprano :super
        (:g)(:g)(:g)(fermata :fs)
        (:d)(:g)(:a)(:bf)(:bf)(:c5)(:bf)(fermata :a)
        (:a)(:bf)(:c5)(:d5 :8th)(:c5 :8th)(:bf)(:ef5)(:ef5)(:d5)(:df5 :8th)(:c5 :8th)(:c5 :h)(fermata :bf)
        (:bf)(:a)(:g)(:f)(:d :8th)(:ef :8th)(:f)(:f)(:g)(:f)(:ef :h)(fermata :d)
        (:d5)(:c5)(:bf :8th)(:a :8th)(:a :h)(fermata :g :h.))

       (:alto :super
        (:d)(:ef :8th)(:d :8th)(:c)(fermata :d)
        (:a3)(:d :8th)(:e :8th)(:fs)(:g)(:g)(:a)(:g)(fermata :fs)
        (:fs)(:g)(:a)(:bf)(:f)(:g :8th)(:a :8th)(:bf)(:bf)(:bf)(:bf)(:a)(fermata :f)
        (:g :8th)(:f :8th)(:ef :8th)(:d :8th)(:e)(:d)(:a3)(:d :8th)(:ef :8th)(:f)(:f :8th)(:ef :8th)(:ef :8th)(:d :8th)(:d :8th)(:c :16th)(:bf3 :16th)(:c)(fermata :bf3)
        (:bf)(:a)(:g)(:g)(:fs)(fermata :d :h.))

       (:tenor :c3 :super
        (:bf)(:bf)(:a :8th)(:g :8th)(fermata :a)
        (:fs)(:g)(:c5)(:d5)(:d5)(:ef5)(:d5)(fermata :d5)
        (:d5)(:d5)(:ef5)(:f5 :8th)(:ef5 :8th)(:d5 :8th)(:c5 :8th)(:bf)(:bf :8th)(:c5 :8th)(:d5 :8th)(:bf :8th)(:g5)(:f5 :q.)(:ef5 :8th)(fermata :d5)
        (:d5)(:c5)(:bf)(:a)(:f)(:bf)(:bf)(:bf)(:a)(:bf)(:f)(fermata :f)
        (:f5)(:ef5)(:d5)(:e5)(:d5 :8th)(:c5 :8th)(fermata :b :h.))

       (:bass :c3 :super
        (:g)(:c :8th)(:d :8th)(:ef)(fermata :d)
        (:c)(:bf3)(:a3)(:g3)(:g)(:fs)(:g)(fermata :d)
        (:d)(:g)(:c5)(:bf)(:af)(:g)(:gf)(:f)(:e)(:f :h)(fermata :bf3)
        (:g3)(:c)(:cs)(:d)(:d :8th)(:c :8th)(:bf3 :8th)(:c :8th)(:d :8th)(:bf3 :8th)(:ef)(:f)(:g)(:a)(fermata :bf)
        (:bf)(:fs)(:g)(:cs)(:d)(fermata :g3 :h.))))

(midi *bwv245*)

(cleave-change :soprano 'cmn::treble)
(cleave-change :alto 'cmn::treble)
(cleave-change :tenor 'cmn::tenor-treble)
(score *bwv245* :key :bf :size 20 :free-expansion-factor 2 :initial-onset 3)